
#include "defextern.h"

#include "main.h"
#include "asciimovie.h"
#include "asciiframe.h"
#include "editproc.h"
#include "color.h"
#include "font.h"
#include "paint.h"



#define RGBback RGB(bcolor.R,bcolor.G,bcolor.B)
#define RGBpen RGB(pencolor.R,pencolor.G,pencolor.B)


int maxsX=GetSystemMetrics(SM_CXSCREEN);
int maxsY=GetSystemMetrics(SM_CYSCREEN);

HPEN penline=CreatePen(PS_SOLID,1,GREEN);
HPEN penb;
HBRUSH brushb;
HBITMAP hbitmap;
int maxX,maxY;


void scroll(int id)
{
	SendMessage (hwndMain, WM_COMMAND, id ,0);
}


void setscrollmax()
{
	scrollmaxnow=min(filesize,scrollmax);
	if(filesize>scrollmax) bigflag=TRUE;
	else bigflag=FALSE;

	SetScrollRange (hwndscroll, SB_CTL, 0, scrollmaxnow, FALSE) ; 
}

void show(HDC &hdc,RECT rect,char *buffer)
{
	if(strlen(buffer)==0) return;
	//RECT rect={0,0,1000,1000};
	SetTextColor(hdc,RED);
	SetBkColor(hdc,BLUE);
	DrawText(hdc,buffer,strlen(buffer),&rect, DT_EDITCONTROL);
}

void redraw()
{
	RECT rect;
	GetClientRect (hwndEdit, &rect) ;
	BitBlt(hdcedit,rect.left,rect.top,rect.right,rect.bottom,hdcsketch,rect.left,rect.top,SRCCOPY);
	//InvalidateRect(hwndEdit,NULL,TRUE);
}

void paint()
{
	LINE(hdcsketch,10,10,300,300);
	circle(hdcsketch,100,100,100);
}

void drawedit()
{
	RECT rect;
	GetClientRect (hwndEdit, &rect) ;
	maxX=rect.right;
	maxY=rect.bottom;
	//memset(buffer,0,buffermax);
	//GetWindowText(hwndEdit,buffer,buffermax);
	Rectangle(hdcsketch,rect.left,rect.top,rect.right,rect.bottom);
	DrawText(hdcsketch,showbuffer,strlen(showbuffer),&rect, DT_EDITCONTROL);
	redraw();
}

void initdrawedit()
{
	RECT rect;
	GetClientRect (hwndEdit, &rect) ;
	maxX=rect.right;
	maxY=rect.bottom;
	//memset(buffer,0,buffermax);
	//GetWindowText(hwndEdit,buffer,buffermax);
	Rectangle(hdcsketch,0,0,maxsX,maxsY);
	//DrawText(hdcsketch,showbuffer,strlen(showbuffer),&rect, DT_EDITCONTROL);
	InvalidateRect(hwndEdit,NULL,TRUE);
	
}

void editshow()
{
	InvalidateRect(hwndEdit,NULL,FALSE);
}

void changecolor()
{
	brushb=CreateSolidBrush(RGBback);
	penb=CreatePen(PS_SOLID,1,RGBpen);
	SetTextColor(hdcsketch,RGBpen);
	SetBkColor(hdcsketch,RGBback);
	DeleteObject(SelectObject(hdcsketch,brushb));
	DeleteObject(SelectObject(hdcsketch,penb));
}

//-----------------------------------------------------------------------
//	Edit proc

LRESULT CALLBACK EditProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT	paintstruct;
	 static HDC hdc;
	 static RECT rect;

     //int id = GetWindowLong (hwnd, GWL_ID) ;
	//HWND	wparent=(HWND)GetWindowLong(hwnd,GWL_HWNDPARENT);
	char buff[50];
          
	
     switch (message)
     {


	 case WM_CREATE://Ă΂ȂH
		 /*
			GetClientRect (hwnd, &rect) ;
		 maxX=1000;
		 maxY=1000;
		 hdc=GetDC(hwndEdit);
		 hdcsketch=CreateCompatibleDC(hdc);
		 hbitmap=CreateCompatibleBitmap(hdc,maxX,maxY);
		 SelectObject(hdcsketch,hbitmap);
		 ReleaseDC(hwndEdit,hdc);
		 */
		 break;

	 case WM_SIZE:
		 editshow();
		 break;

	 case WM_PAINT:
			GetUpdateRect (hwnd, &rect,FALSE) ;
			hdc=BeginPaint(hwnd,&paintstruct);
			 if(hdcsketch==NULL)
			 {
				 hdcedit=GetDC(hwndEdit);
				InitColor();
				brushb=CreateSolidBrush(RGBback);
				penb=CreatePen(PS_SOLID,1,RGBpen);
				 hdcsketch=CreateCompatibleDC(hdc);
				 hbitmap=CreateCompatibleBitmap(hdc,maxsX,maxsY);
				 SelectObject(hdcsketch,hbitmap);
				SelectObject(hdcsketch,penb);
				SetTextColor(hdcsketch,RGBpen);
				SetBkColor(hdcsketch,RGBback);
				SetBkColor(hdc,RGBback);
				SetFont(hdcsketch);
				SelectObject(hdcsketch,brushb);
				SelectObject(hdc,brushb);
				initdrawedit();
			 }
			 if(playing==FALSE) 
			 {
				 GetWindowText(hwnd,showbuffer,buffermax);
				 drawedit();
			 }
			EndPaint(hwnd,&paintstruct);
		 break;

	case WM_KILLFOCUS:
		break ;  

	case WM_DESTROY:
		DeleteObject(penline);
		DeleteObject(penb);
		DeleteObject(brushb);
		DeleteDC(hdcsketch);
		ReleaseDC(hwndEdit,hdcedit);
		DeleteDC(hdcedit);
		break ;    
     }
	 return CallWindowProc ((FARPROC) OldEdit, hwnd, message, wParam, lParam) ;
}
