
//--------------------------------------
//	AXL[[r[
//	
//	
//	2002/07/20-
//	1991-2002 Copyright Tabasa & charlie, All rights reserved
// 	happypoint@geocities.co.jp
//	http://www.geocities.co.jp/SiliconValley-Bay/6716/
//
//


#define	_main

#include "defextern.h"

#include "main.h"
//#include <richedit.h>
#include "asciimovie.h"
#include "asciiframe.h"
#include "commandline.h"
#include "file.h"
#include "editproc.h"
#include "font.h"
#include "color.h"

BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
HINSTANCE hInstance;
char AppName[]="asciimovie";
char TopName[]="AXL[[r[";
char fontfile[MAX_PATH]="font.ini";
char initialdir[MAX_PATH];

char soundname[MAX_PATH];
char filename[MAX_PATH];
#define buffermin 320
int edittopX=5;
int edittopY=35;
int defX=160;
int defY=430;

int posstep=1000;
int stepmore=1000;
int stepmost=100000;
//char buffer [buffermax+1]="ready.";
ULONG length=1000;
int timerinterval;
int id_timer=1;

//ifstream in;



int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
	hInstance=hInst;
	
	setcommandline(szCmdLine);
     if (-1 == DialogBox (hInstance, AppName, NULL, (int (__stdcall *)(void))DlgProc))
     {
          MessageBox (NULL, TEXT ("error"),
                      AppName, MB_ICONERROR) ;
     }
     return 0 ;
}


void resettimer()
{
	SendMessage (hwndMain, WM_COMMAND, IDC_play_end ,0);
	SendMessage (hwndMain, WM_COMMAND, IDC_play ,0);
}


void settimerinterval(int i)
{
	timerinterval=i;
	if(playing) resettimer();
}

void reset(ifstream &in)
{
	in.close();
	in.clear();
	in.open(filename,ios::binary | ios::nocreate);
	//pos =0;
}

void setpos(ifstream &in)
{
	reset(in);
	in.seekg(pos,ios::beg);
}


void title(HWND hwnd,char *filename,char *thisname)
{
	char title[MAX_PATH *2];

	sprintf(title,"%s..%s",filename,thisname);
	SetWindowText(hwnd,title);

}


//---------------------------------------------
// ǂݍ݁A\
// ̍s

void show(ifstream &in)
{
	char *buff,*start;
	int count,countstart=0;
	BOOL flag=FALSE;
	in.read(buffer,buffermax);
	count=in.gcount();
	if(count==0)
	{
		reset(in);
		in.seekg(-buffermin,ios::end);
		if(!in.good()) reset(in);
		in.read(buffer,buffermax);
		count=in.gcount();
	}
	if(count<buffermax)
	{
		reset(in);
		in.seekg(-count,ios::end);
	}
	else
	{
		in.seekg(-count,ios::cur);
	}
	buff=&(buffer[0]);
	start=buff;
	for(int i=0;i<count;i++,buff++)
	{
		if(*buff=='\0') *buff=' ';
		if(pos!=0 && !flag && *buff==0x0a) //蔲@s
		{
			flag=TRUE;
			start=buff+1;
			countstart=i;
		}
	}
	buffer[count]='\0';
	/*
	SetBkMode(GetWindowDC(hwndEdit),OPAQUE);
	SetTextColor(GetWindowDC(hwndEdit),RGB(0,199,10));
	*/
	SetWindowText(hwndEdit,start);
	wsprintf(buffer,"%ld",getframenum());
	SetDlgItemText(hwndMain,IDC_EDIT1,buffer);
	setscrollmax();
	if(!bigflag)
	{
		SetScrollPos (hwndscroll, SB_CTL, pos, TRUE) ;
	}
	else
	{
		SetScrollPos (hwndscroll, SB_CTL, PosToScroll(pos), TRUE) ;
	}
}

void posplus(ifstream &in,int posplus)
{
	if(!in) return;
	streampos now=in.tellg();
	ULONG posback =pos;
	in.seekg(posplus,ios::cur);
	pos += posplus;
	if(pos>filesize) pos=filesize;
	if(!in.good() && posplus>0)
	{
		reset(in);
		in.seekg(now);
		pos =posback;
	}
	else if(!in.good() && posplus<0)
	{
		reset(in);
		pos =0;
	}
}

void getposedit(ifstream &in,ULONG &pos)
{
	reset(in);
	GetDlgItemText(hwndMain,IDC_EDIT1,buffer,buffermax);
	sscanf(buffer,"%ld",&pos);
	in.seekg(pos,ios::beg);
}

void ending(HWND hwnd)
{
	if(buffer!=NULL)free(buffer);
	if(showbuffer!=NULL)free(showbuffer);
	FontDeinitialize ();
	EndDialog (hwnd, 0) ;
}


//--------------------------------------
//	C



BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT	paintstruct;
	 HDC hdc;
	 WORD cxClient,cyClient;

	 ULONG i,j;
	

     switch (message)
     {
		case WM_INITDIALOG:
			buffer = (char*)malloc (buffermax+1) ;
			showbuffer = (char*)malloc (buffermax+1) ;
			hwndMain=hwnd;
			setOpenFileExtTxt();
			PopFileInitialize (hwnd);
			SetWindowText(hwnd,TopName);
			setmode(MODE_MAKING);
			playing=FALSE;
			colorflag=FALSE;
			SetClassLong(hwnd,GCL_HICON,
				(long)LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1)) );
			
          hwndEdit = CreateWindow (TEXT ("edit"), NULL,
                           WS_CHILD | WS_VISIBLE |WS_HSCROLL |
                                   WS_BORDER | ES_LEFT | ES_MULTILINE | ES_WANTRETURN|
                                   ES_AUTOHSCROLL | ES_AUTOVSCROLL,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                         hwnd, NULL, hInstance,NULL) ;
		  OldEdit = (WNDPROC) SetWindowLong (hwndEdit, GWL_WNDPROC, (LONG) EditProc) ;
		  //OldEdit = (WNDPROC) GetWindowLong (hwndEdit, GWL_WNDPROC) ;
		  hwndscroll = CreateWindow (TEXT ("scrollbar"), NULL,
							WS_CHILD | WS_VISIBLE | 
							WS_TABSTOP | SBS_VERT,
							0,0,0,0,
							 hwnd, NULL, hInstance, NULL) ;
		  SetScrollRange (hwndscroll, SB_CTL, 0,0, TRUE) ;
		  getini_ex(initialdir);
		  wsprintf(buffer,"%s\%s",initialdir,fontfile);
		  strcpy(fontfile,buffer);
			FontInitialize (hwndEdit,fontfile);
			FontSetFont (hwndEdit);

		  pos=0;
		  SendMessage (hwnd, WM_SIZE, 0 , (LPARAM) MAKELONG(defY,defX) ) ;
		  DragAcceptFiles(hwnd,TRUE);
		  if(cmdflag)
		  {
			  FncCommandline(filename);
			  SendMessage (hwnd, WM_COMMAND, IDC_FILE_READ ,0);
		  }
		  SendMessage (hwnd, WM_COMMAND, IDM_speed_3 ,0);
		//initdrawedit();
		return TRUE ;


		case WM_VSCROLL :
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               scroll (IDC_NEXT2);
			   break;

          case SB_LINEDOWN :
               scroll (IDC_NEXT);
               break ;
               
          case SB_PAGEUP :
               scroll (IDC_BACK2 );
               break;

          case SB_LINEUP :
               scroll (IDC_BACK );
               break ;
               
          case SB_TOP :
               scroll (IDC_BACK_MOST );
               break ;
               
          case SB_BOTTOM :
               scroll (IDC_NEXT_MOST );
               break ;

		case SB_THUMBTRACK :
               if(!bigflag) pos = HIWORD (wParam);
			   else pos = (double)HIWORD (wParam) /scrollmax *filesize;
			   //setpos(in);
			   //show(in);
               break ;

          default :
               break ;
          }

		break;

	case WM_TIMER:
		if(playing)// scroll (IDC_NEXT);
		{
			  framenumplus(1);
			  loadframe(filename);
			  //if(colorflag==FALSE) editshow();
		}
		else KillTimer(hwnd,id_timer);
		break;

	case WM_DROPFILES:
		DragQueryFile((HDROP)wParam,0,filename,MAX_PATH);
		SendMessage (hwnd, WM_COMMAND, IDC_FILE_READ ,0);
		break;

     case WM_SIZE : 
          cxClient = LOWORD (lParam) ;
          cyClient = HIWORD (lParam) ;
		 MoveWindow (hwndEdit, edittopX, edittopY,
                           cxClient-edittopX-25, cyClient-edittopY-5, TRUE) ;

		 MoveWindow (hwndscroll, cxClient-edittopX-18, edittopY,
                           13, cyClient-edittopY-5, TRUE) ;
         return 0 ;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {
		  case IDC_FILE_NEW:
			  break;

		  case IDC_FILE_OPEN:
			  setOpenFileExtTxt();
			  PopFileOpenDlg (hwnd,filename,NULL);
		  case IDC_FILE_READ:
			  offextention(filename);
			  pos=0;
			  //reset(in);
			  filesize=getfilesize(filename);
			  title(hwnd,filename,TopName);//
			  loadcolor(filename);
			  resetcopy();
			  SetCurrentDirectoryFile(filename);
			  break;

		  case IDM_soundfile:
			  setOpenFileExtWav();
			  if(PopFileOpenDlg (hwnd,soundname,NULL))
			  {
				  if(CompareDirectory(soundname,filename)==0) OffDirectory(soundname);
				  SetSoundName(soundname);
				  saveframe(filename);
			  }
			  break;

		  case IDM_soundlisten:
			  Sound();
			  break;

		  case IDC_BACK:
			  framenumplus(-1);
			  loadframe(filename);
			  //show(in);
			  break;

		  case IDC_BACK2:
			  framenumplus(-10);
			  loadframe(filename);
			  break;

		  case IDC_BACK3:
			  framenumplus(-100);
			  loadframe(filename);
			  break;

		  case IDC_BACK_MOST:
			  framenumreset();
			  loadframe(filename);
			  break;

		  case IDC_NEXT:
			  framenumplus(1);
			  loadframe(filename);
			  //show(in);
			  break;

		  case IDC_NEXT2:
			  framenumplus(10);
			  loadframe(filename);
			  //show(in);
			  break;

		  case IDC_NEXT3:
			  framenumplus(100);
			  loadframe(filename);
			  //show(in);
			  break;

		  case IDC_NEXT_MOST:
			  //show(in);
			  break;


		  case IDM_speed_1:
			  settimerinterval(1000);
			  break;

		  case IDM_speed_2:
			  settimerinterval(500);
			  break;

		  case IDM_speed_3:
			  settimerinterval(200);
			  break;

		  case IDM_speed_4:
			  settimerinterval(100);
			  break;

		  case IDM_speed_5:
			  settimerinterval(50);
			  break;

		  case IDM_speed_6:
			  settimerinterval(30);
			  break;

		  case IDM_copy_to_next:
			  copytonext(filename);
			  scroll (IDC_NEXT);
			  break;

		  case IDM_copy:
			  copyframe();
			  break;

		  case IDM_paste:
			  pasteframe(filename);
			  loadframe(filename);
			  break;

		  case IDM_insert:
			  insertframe(filename);
			  loadframe(filename);
			  break;

		  case IDM_delete:
			  deleteframe(filename);
			  loadframe(filename);
			  break;

		  case IDC_play:
			  playing=TRUE;
			  loadcolor(filename);
			  SetTimer(hwnd,id_timer,timerinterval,NULL);
			  editshow();
			  break;

		  case IDC_play_end:
			  playing=FALSE;
			  KillTimer(hwnd,id_timer);
			  break;

		  case IDM_mode_all:
			  setmode(MODE_ALL);
			  loadcolor(filename);
			  break;
			  
		  case IDM_mode_making:
			  setmode(MODE_MAKING);
			  loadcolor(filename);
			  break;

		  case IDM_font:
			  FontChooseFont (hwndEdit);
			  FontSetFont(hwndEdit);
			  SetFont(hdcsketch);
			  break;

		  case IDM_SAVE_COLORS:
			  savecolor(filename);
			  break;

		  case IDM_color:
			  PenChooseColor ();
			  saveframe(filename);
			  break;

		  case IDM_color_back:
			  BackChooseColor ();
			  saveframe(filename);
			  break;

		  case IDM_color_on:
			  SetWindowLong (hwndEdit, GWL_WNDPROC, (LONG) EditProc) ;
			  loadcolor(filename);
			  colorflag=TRUE;
			  editshow();
			  break;

		  case IDM_color_off:
			  SetWindowLong (hwndEdit, GWL_WNDPROC, (LONG) OldEdit) ;
			  colorflag=FALSE;
			  break;

		  case IDM_load_font:
			  loadfont(fontfile);
			  FontSetFont (hwndEdit);
			  break;

		  case IDM_save_font:
			  savefont(fontfile);
			  break;

		  case IDC_SAVE:
			  saveframe(filename);
			  break;

		  case IDC_FILE_SAVE:
			  saveallframe(filename);
			  break;

		  case IDC_FRAME_TO_FILE:
			  filetoframe(filename);
			  break;

		  case IDCANCEL:
			  ending(hwnd);
			  break;

          }
          break ;


     case WM_SYSCOMMAND:
          switch (LOWORD (wParam))
          {
          case SC_CLOSE:
			  //XbhI
			  ending(hwnd);
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}
