
#include "defextern.h"
#include <iostream.h>
#include <windows.h>
#include <fstream.h>
#include <commdlg.h>
#include "color.h"
#include "editproc.h"




void setcolor(RGBcolor &co,int r,int g,int b)
{
	co.R=r;
	co.G=g;
	co.B=b;
}

void InitColor()
{
	setcolor(pencolor,0,0,0);
	setcolor(bcolor,255,255,255);
}

COLORREF ColorChooseColor ()
{
	CHOOSECOLOR cc;
	COLORREF crs[16];
	cc.lStructSize=sizeof(CHOOSECOLOR);
	cc.hwndOwner=NULL;
	cc.hInstance=NULL;
	cc.rgbResult=RGB(0x80,0x80,0x80);
	cc.lpCustColors=crs;
	cc.Flags=CC_RGBINIT | CC_FULLOPEN;
	cc.lCustData=0;
	cc.lpfnHook=NULL;
	cc.lpTemplateName=NULL;
	ChooseColor(&cc);

	return cc.rgbResult;
}

void PenChooseColor()
{
	COLORREF c=ColorChooseColor();
	pencolor.R=GetRValue(c);
	pencolor.G=GetGValue(c);
	pencolor.B=GetBValue(c);
	changecolor();
}

void BackChooseColor()
{
	COLORREF c=ColorChooseColor();
	bcolor.R=GetRValue(c);
	bcolor.G=GetGValue(c);
	bcolor.B=GetBValue(c);
	changecolor();
}
