#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "resource.h"
#include "file.h"

//hFile
OPENFILENAME ofn;


TCHAR *szFilter;
char pathbuffer[MAX_PATH];

//-----------------------------------------------------------------------
//	

void PopFileInitialize (HWND hwnd)
{
     static char ext[3];
     ofn.lStructSize       = sizeof (OPENFILENAME) ;
     ofn.hwndOwner         = hwnd ;
     ofn.hInstance         = NULL ;
     ofn.lpstrFilter       = szFilter ;
     ofn.lpstrCustomFilter = NULL ;
     ofn.nMaxCustFilter    = 0 ;
     ofn.nFilterIndex      = 0 ;
     ofn.lpstrFile         = NULL ;          // Set in Open and Close functions
     ofn.nMaxFile          = MAX_PATH ;
     ofn.lpstrFileTitle    = NULL ;          // Set in Open and Close functions
     ofn.nMaxFileTitle     = MAX_PATH ;
     ofn.lpstrInitialDir   = NULL ;
     ofn.lpstrTitle        = NULL ;
     ofn.Flags             = 0 ;             // Set in Open and Close functions
     ofn.nFileOffset       = 0 ;
     ofn.nFileExtension    = 0 ;
     ofn.lpstrDefExt       = ext ;
     ofn.lCustData         = 0L ;
     ofn.lpfnHook          = NULL ;
     ofn.lpTemplateName    = NULL ;
}

void setOpenFileExtWav()
{
     static TCHAR szFilterWav[] = TEXT ("wav Files (*.wav)\0*.wav\0") \
                               TEXT ("All Files (*.*)\0*.*\0\0") ;
     ofn.lpstrFilter       = szFilterWav;
     ofn.lpstrDefExt ="wav";
}

void setOpenFileExtTxt()
{
     static TCHAR szFilterTxt[] = TEXT ("eLXg Files (*.txt)\0*.txt\0") \
                                TEXT ("All Files (*.*)\0*.*\0");
     ofn.lpstrFilter       = szFilterTxt;
     ofn.lpstrDefExt ="txt";
}

//-----------------------------------------------------------------------
//	

BOOL PopFileOpenDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName)
{
     ofn.hwndOwner         = hwnd ;
     ofn.lpstrFile         = pstrFileName ;
     ofn.lpstrFileTitle    = pstrTitleName ;
     ofn.Flags             = OFN_HIDEREADONLY | OFN_CREATEPROMPT ;
     
     return GetOpenFileName (&ofn) ;
}

//...................................
//	gqŐVt@C


void makenewfilename(char *filename,char *newfile,char *new_ad)
{
	char ext[6]="";
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(ext,"%s",pB+1);
		 wsprintf(pB,"%s.%s",new_ad,ext);
	 }
	 else wsprintf(newfile,"%s%s.%s",filename,new_ad,ext);
}

//...................................
//	gqŐVt@CAAԗp,max999


void makenewfilename(char *filename,char *newfile,DWORD num)
{
	char ext[6]="";
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(ext,"%s",pB+1);
		 wsprintf(pB,"_%03d.%s",num,ext);
	 }
	 else wsprintf(newfile,"%s_%03d.%s",newfile,num,ext);
}

//...................................
//	t@CA`FbN

BOOL checkfilename(char *filename,char *nextfile)
{
	char *buff=pathbuffer;
	ifstream in;
	char ext[6]="";
	ULONG num=0;
	char *pB;
	wsprintf(buff,filename);
	 pB=strrchr(buff,'_');
	 if(pB!=NULL) *pB='\0';
	 pB=strrchr(filename,'_');
	 if(pB!=NULL) 
	 {
		 pB++;
		 wsprintf(nextfile,pB);
		 pB=strrchr(nextfile,'.');
		 wsprintf(ext,pB+1);
		 *pB='\0';
		 sscanf(nextfile,"%d",&num);
		 wsprintf(nextfile,"%s_%03d.%s",buff,num+1,ext);
		 in.open(nextfile,ios::binary | ios::nocreate);
		 if(!in)
		 {
			 num=0;
			 wsprintf(nextfile,filename);
		 }

	 }
	 else 
	 {
		 pB=strrchr(filename,'\\');
		 if(pB!=NULL) pB++;
		 else pB=filename;
		 sscanf(pB,"%s",nextfile);
	 }

	 if(num>0) return TRUE;
	 else return FALSE;
}


//...................................
//	tH_ɐVt@C


void makenewfilename(char *filename,char *newfile,char *new_ad,char *ext)
{
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(pB,"%s.%s",new_ad,ext);
	 }
	 else wsprintf(newfile,"%s%s.%s",filename,new_ad,ext);
}

//NfBNg

void getini_ex(char*initial)
{
	char cdf[MAX_PATH],cddr[MAX_PATH],cddi[MAX_PATH];
	GetModuleFileName(NULL,cdf,MAX_PATH);
	_splitpath(cdf,cddr,cddi,NULL,NULL);
	wsprintf(initial,"%s%s",cddr,cddi);
	//strcpy(initial,cddr);
	//strcat(initial,cddi);
}

	
//JgfBNg

void getini_cu(char*initial,char*initialfile)
{
	char *cd=pathbuffer;
	GetCurrentDirectory(MAX_PATH,cd);
	wsprintf(initial,"%s\\%s",cd,initialfile);
}

//t@C@JgfBNg@Zbg

void SetCurrentDirectoryFile(char*file)
{
	char *cd=pathbuffer;
	char *p;
	strcpy(cd,file);
	p=strrchr(cd,'\\');
	if(p==NULL) return;
	*p='\0';
	SetCurrentDirectory(cd);
}

//t@C@fBNgO

void OffDirectory(char *file)
{
	char *p;
	strcpy(pathbuffer,file);
	p=strrchr(pathbuffer,'\\');
	if(p!=NULL) strcpy(file,p+1);
}

//̃t@Ć@fBNgׂ

int CompareDirectory(char *file0,char *file1)
{
	char f0[MAX_PATH],f1[MAX_PATH];
	char *p;
	int ans;
	strcpy(f0,file0);
	strcpy(f1,file1);
	p=strrchr(f0,'\\');
	if(p==NULL) return 1;
	*p='\0';
	p=strrchr(f1,'\\');
	if(p==NULL) return 1;
	*p='\0';
	ans=strcmp(f0,f1);
	return ans;
}



//........................................
//	t@CTCY

DWORD getfilesize(char *buffname)
{
	//check length
	DWORD size=0;
	HANDLE f;
	f=CreateFile(buffname,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(f!=NULL) size=max(GetFileSize(f,NULL),0);
	CloseHandle(f);
	return size;
}


void copyfile(ifstream &in,ofstream &ou)
{
	char buffer[1000];
	do
	{
		in.read(buffer,1000);
		ou.write(buffer,in.gcount());
	}
	while (!in.eof());
}

//
// gq͂

void offextention(char *file)
{
	char *c=strrchr(file,'.');
	if(c!=NULL) *c='\0';
}